//  Fish Supper
//  Copyright (C) 2006 Matthew Clarke <matthew_larcke@lycos.co.uk>
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.




#ifndef _CRYSTAL_H_
#define _CRYSTAL_H_




#include "mapsprite.h"
#include "enums.h"
#include "constants.h"
#include "playdisplay.h"




namespace FS
{
    
class Crystal : public MapSprite
{
    private :
        //CrystalColor my_color;
        CrystalColor original_color;
        CrystalColor current_color;
        
        bool at_front;
        bool at_back;
        
        bool update_visible;    // botch-job!
        
        int collision_pixel_x;
        int collision_pixel_y;
        
    public:
        Crystal();
        ~Crystal();
        
        CrystalColor get_color() const { return current_color; }
        void set_color(CrystalColor cc) { current_color = cc; }
        
        void init(int mx, int r, int yy, int w, int h, CrystalColor c, bool af, bool ab,
                int rlp, Direction d);
        
        void update(int current_start_pixel, int pixels_moved, bool is_first_pass,
                PlayDisplay * pd);
        
        bool is_update_visible() const { return update_visible; }
        
        int get_collision_pixel_x() const { return sprite_rect.x + collision_pixel_x; }
        int get_collision_pixel_y() const { return sprite_rect.y + collision_pixel_y; }
        
        void reset();
        
}; // class Crystal

} // namespace FS




#endif

                
