//  Fish Supper
//  Copyright (C) 2006 Matthew Clarke <matthew_larcke@lycos.co.uk>
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.




#ifndef _ENUMS_H_
#define _ENUMS_H_




namespace FS
{

const int SCREEN_WIDTH = 800;
const int SCREEN_HEIGHT = 600;
const int BPP = 8; // i.e. Bits Per Pixel

enum LogColor
{
    L_RED,
    L_YELLOW,
    L_BLUE,
    L_ORANGE,
    L_GREEN,
    L_PURPLE,
    L_BROWN,
    L_BACKGROUND
}; // enum LogColor

enum CrystalColor
{
    C_RED,
    C_YELLOW,
    C_BLUE,
    C_WHITE,
    C_NONE
}; // enum CrystalColor

struct Block
{
    LogColor lc;
    CrystalColor cc;
}; // struct Block

enum Direction
{
    LEFT_TO_RIGHT,
    RIGHT_TO_LEFT
}; // enum Direction

// These relate to Albert:
enum Orientation
{
    NORTH, EAST, SOUTH, WEST
}; // enum Orientation

enum KeyboardEvent
{
    UP_KEY_PRESSED,
    RIGHT_KEY_PRESSED,
    DOWN_KEY_PRESSED,
    LEFT_KEY_PRESSED,
    JUMP_KEY_PRESSED,
    ESCAPE_PRESSED,
    PAUSE_KEY_PRESSED,
    UP_KEY_RELEASED,
    RIGHT_KEY_RELEASED,
    DOWN_KEY_RELEASED,
    LEFT_KEY_RELEASED,
    NONE
}; // enum KeyboardEvent
        
enum TurnType
{
    CLOCKWISE, ANTI_CLOCKWISE
}; // enum TurnType
    
enum Strip
{
    WALKING_NORTH,
    WALKING_EAST,
    WALKING_SOUTH,
    WALKING_WEST,
    JUMPING_NORTH,
    JUMPING_EAST,
    JUMPING_SOUTH,
    JUMPING_WEST
}; // enum Strip
 
enum RowDescription
{
    ROW_0,
    ROW_1,
    ROW_2,
    ROW_3,
    ROW_4,
    ROW_5,
    UPPER_BANK,
    LOWER_BANK,
    WATER
}; // RowDescription

const int IMAGE_ID_LOG_OFFSET = 1;
const int IMAGE_ID_CRYSTAL_OFFSET = 8;
const int NUM_IMAGES = 27;
enum ImageIDs
{
    BACKGROUND,
    LOG_RED,
    LOG_YELLOW,
    LOG_BLUE,
    LOG_ORANGE,
    LOG_GREEN,
    LOG_PURPLE,
    LOG_BROWN,
    CRYSTAL_RED,
    CRYSTAL_YELLOW,
    CRYSTAL_BLUE,
    CRYSTAL_WHITE,
    WALKING_N,
    WALKING_E,
    WALKING_S,
    WALKING_W,
    JUMPING_N,
    JUMPING_E,
    JUMPING_S,
    JUMPING_W,
    SPLASHING_N,
    SPLASHING_E,
    SPLASHING_S,
    SPLASHING_W,
    ZAPPING_NESW,
    FISH,
    WALKING_E_WITH_FISH
}; // enum ImageIDs
           
enum PlayReport
{
    PR_OK, 
    PR_LEVEL_COMPLETED, 
    PR_GAME_OVER,
    PR_GAME_ABORTED
}; // enum PlayReport
    
} // namespace FS

    

    
#endif

        
