//  Fish Supper
//  Copyright (C) 2006 Matthew Clarke <matthew_larcke@lycos.co.uk>
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.




#ifndef _LOG_H_
#define _LOG_H_




#include "mapsprite.h"
#include "enums.h"
#include "playdisplay.h"




namespace FS
{
    
class Log : public MapSprite
{
    private:
        LogColor my_color;
        
        SDL_Rect fill_rect;
        bool fill_visible;
        
        SDL_Rect sprite_size_rect;  // ? This is a HACK!

        void process_first_pass();
        void schedule_drawing(PlayDisplay * pd);
        void print_data();
        
        int num_pixels_moved;
        
    public:
        Log();
        ~Log();
        
        LogColor get_color() const { return my_color; }
        
        void set_color(LogColor c) { my_color = c; }
        void set_map_x(int mx) { map_x = mx; } 
        
        int get_map_x() const { return map_x; }
        
        void init(int yy, int w, int h, LogColor c, int mx, int rlp, Direction d, int r);
        
        void update(int current_start_pixel, int pixels_moved, bool is_first_pass,
                PlayDisplay * pd);
        
        bool is_fill_visible() const { return fill_visible; }
        
        SDL_Rect * get_fill_rect() { return &fill_rect; }
        
        int get_num_pixels_moved() const { return num_pixels_moved; }
        
        SDL_Rect * get_sprite_size_rect() { return &sprite_size_rect; }
        
        int get_sprite_rect_x() const { return sprite_rect.x; }
            
}; // class Log

} // namespace FS




#endif
    
