//  Fish Supper
//  Copyright (C) 2006 Matthew Clarke <matthew_larcke@lycos.co.uk>
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.




#ifndef _SOUNDENGINE_H_
#define _SOUNDENGINE_H_




#include "SDL_mixer.h"




namespace FS
{

class SoundEngine
{
    private:
        static const int NUM_SOUNDS = 4;
    
        Mix_Chunk * sounds[NUM_SOUNDS];

    public:
        enum SoundIDs { MIAOW, SPLASH, RIVER, PING };
    
        SoundEngine();
        ~SoundEngine();
        
        void play_sound(SoundIDs sid, int channel = -1, int loops = 0, int volume = 128);
        void stop_sound(int channel);
        
}; // class SoundEngine

} // namespace FS




#endif
            
